#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 worldNormal;
out vec2 fUVs;
out vec3 vertexPosition;
out vec4 vertexPosShadowMap;

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 meshMatrix;
uniform mat4 projectionLightSource;

void main() {

	gl_Position = projectionMatrix * modelMatrix * meshMatrix * vec4(position, 1);
	vertexPosition = (modelMatrix * vec4(position, 1)).xyz;
	vertexPosShadowMap = projectionLightSource * modelMatrix * meshMatrix * vec4(position, 1);

	//worldNormal = (projectionMatrix * modelMatrix * vec4(normal, 0)).xyz;
	mat4 normalMatrix = transpose(inverse(modelMatrix*meshMatrix));
	worldNormal = (normalMatrix * vec4(normal, 0)).xyz;
	fUVs = uv;
	float range = 0.0f;
}