#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;
in vec3 vertexColor;

out vec3 worldNormal;
out vec2 fUVs;
out vec3 vertexPosition;
out vec4 vertexPosShadowMap;

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 projectionLightSource;
//uniform vec2 coloredVertices[];

void main() {

	gl_Position = projectionMatrix * modelMatrix * vec4(position, 1);
	vertexPosition = (modelMatrix * vec4(position, 1)).xyz;
	vertexPosShadowMap = projectionLightSource * modelMatrix * vec4(position, 1);
	mat4 normalMatrix = transpose(inverse(modelMatrix));
	worldNormal = (normalMatrix * vec4(normal, 0)).xyz;
	fUVs = uv;
}